"""
    FactSet Fundamentals API

    Gain access to current, comprehensive, and comparative information on securities in worldwide developed and emerging markets. Composed of annual and interim/quarterly data, detailed historical financial statement content, per-share data, and calculated ratios, FactSet Fundamentals provides you with the information you need for a global investment perspective.<p>This API is rate-limited to 10 requests per second and 10 concurrent requests per user.</p>   # noqa: E501

    The version of the OpenAPI document: 2.2.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetFundamentals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetFundamentals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.FactSetFundamentals.model.address import Address
    from fds.sdk.FactSetFundamentals.model.company_report_error_object import CompanyReportErrorObject
    from fds.sdk.FactSetFundamentals.model.exchange import Exchange
    globals()['Address'] = Address
    globals()['CompanyReportErrorObject'] = CompanyReportErrorObject
    globals()['Exchange'] = Exchange


class Profile(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'request_id': (str,),  # noqa: E501
            'error': (CompanyReportErrorObject,),  # noqa: E501
            'fsym_id': (str, none_type,),  # noqa: E501
            'ticker_region': (str, none_type,),  # noqa: E501
            'exchange': (Exchange,),  # noqa: E501
            'name': (str, none_type,),  # noqa: E501
            'address': (Address,),  # noqa: E501
            'industry_id': (str, none_type,),  # noqa: E501
            'industry': (str, none_type,),  # noqa: E501
            'sector_id': (str, none_type,),  # noqa: E501
            'sector': (str, none_type,),  # noqa: E501
            'number_of_employees': (int, none_type,),  # noqa: E501
            'ceo': (str, none_type,),  # noqa: E501
            'business_summary': (str, none_type,),  # noqa: E501
            'year_founded': (int, none_type,),  # noqa: E501
            'market_capitalization': (int, none_type,),  # noqa: E501
            'total_market_capitalization': (int, none_type,),  # noqa: E501
            'shares_outstanding': (int, none_type,),  # noqa: E501
            'pe_ratio': (float, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'request_id': 'requestId',  # noqa: E501
        'error': 'error',  # noqa: E501
        'fsym_id': 'fsymId',  # noqa: E501
        'ticker_region': 'tickerRegion',  # noqa: E501
        'exchange': 'exchange',  # noqa: E501
        'name': 'name',  # noqa: E501
        'address': 'address',  # noqa: E501
        'industry_id': 'industryId',  # noqa: E501
        'industry': 'industry',  # noqa: E501
        'sector_id': 'sectorId',  # noqa: E501
        'sector': 'sector',  # noqa: E501
        'number_of_employees': 'numberOfEmployees',  # noqa: E501
        'ceo': 'ceo',  # noqa: E501
        'business_summary': 'businessSummary',  # noqa: E501
        'year_founded': 'yearFounded',  # noqa: E501
        'market_capitalization': 'marketCapitalization',  # noqa: E501
        'total_market_capitalization': 'totalMarketCapitalization',  # noqa: E501
        'shares_outstanding': 'sharesOutstanding',  # noqa: E501
        'pe_ratio': 'peRatio',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Profile - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            request_id (str): Identifier that was used for the request.. [optional]  # noqa: E501
            error (CompanyReportErrorObject): [optional]  # noqa: E501
            fsym_id (str, none_type): FactSet Regional Security Identifier. Six alpha-numeric characters, excluding vowels, with an -R suffix (XXXXXX-R). Identifies the security's best regional security data series per currency. For equities, all primary listings per region and currency are allocated a regional-level permanent identifier. The regional-level permanent identifier will be available once a SEDOL representing the region/currency has been allocated and the identifiers are on FactSet.. [optional]  # noqa: E501
            ticker_region (str, none_type): FactSet Ticker-Region for the requested security.. [optional]  # noqa: E501
            exchange (Exchange): [optional]  # noqa: E501
            name (str, none_type): Name of the security. [optional]  # noqa: E501
            address (Address): [optional]  # noqa: E501
            industry_id (str, none_type): The industry classification Id for this security. The industry level 5 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            industry (str, none_type): The industry classification for this security. The industry level 5 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            sector_id (str, none_type): The sector classification Id for this security. The sector level 2 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            sector (str, none_type): The sector classification for this security. The sector level 2 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            number_of_employees (int, none_type): Number of employees working in the company. [optional]  # noqa: E501
            ceo (str, none_type): A chief executive officer (CEO) is the highest-ranking executive in a company. [optional]  # noqa: E501
            business_summary (str, none_type): Summary of the security being requested. [optional]  # noqa: E501
            year_founded (int, none_type): The year this security is founded. [optional]  # noqa: E501
            market_capitalization (int, none_type): The market capitalization of a company. It is the total value of the company's outstanding shares of common stock. [optional]  # noqa: E501
            total_market_capitalization (int, none_type): The total public shares for the company's listed equity. This aggregates across all share classes, with including non-traded shares.. [optional]  # noqa: E501
            shares_outstanding (int, none_type): The number of common shares that a company has issued and are held by investors. [optional]  # noqa: E501
            pe_ratio (float, none_type): The price-earnings ratio (P/E ratio) is the ratio for valuing a company that measures its current share price relative to its per-share earnings (EPS). [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Profile - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            request_id (str): Identifier that was used for the request.. [optional]  # noqa: E501
            error (CompanyReportErrorObject): [optional]  # noqa: E501
            fsym_id (str, none_type): FactSet Regional Security Identifier. Six alpha-numeric characters, excluding vowels, with an -R suffix (XXXXXX-R). Identifies the security's best regional security data series per currency. For equities, all primary listings per region and currency are allocated a regional-level permanent identifier. The regional-level permanent identifier will be available once a SEDOL representing the region/currency has been allocated and the identifiers are on FactSet.. [optional]  # noqa: E501
            ticker_region (str, none_type): FactSet Ticker-Region for the requested security.. [optional]  # noqa: E501
            exchange (Exchange): [optional]  # noqa: E501
            name (str, none_type): Name of the security. [optional]  # noqa: E501
            address (Address): [optional]  # noqa: E501
            industry_id (str, none_type): The industry classification Id for this security. The industry level 5 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            industry (str, none_type): The industry classification for this security. The industry level 5 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            sector_id (str, none_type): The sector classification Id for this security. The sector level 2 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            sector (str, none_type): The sector classification for this security. The sector level 2 RBIC (Revere Business Industry Classification) system is used in classification. For more info, visit: [OA page](https://my.apps.factset.com/oa/pages/17498). [optional]  # noqa: E501
            number_of_employees (int, none_type): Number of employees working in the company. [optional]  # noqa: E501
            ceo (str, none_type): A chief executive officer (CEO) is the highest-ranking executive in a company. [optional]  # noqa: E501
            business_summary (str, none_type): Summary of the security being requested. [optional]  # noqa: E501
            year_founded (int, none_type): The year this security is founded. [optional]  # noqa: E501
            market_capitalization (int, none_type): The market capitalization of a company. It is the total value of the company's outstanding shares of common stock. [optional]  # noqa: E501
            total_market_capitalization (int, none_type): The total public shares for the company's listed equity. This aggregates across all share classes, with including non-traded shares.. [optional]  # noqa: E501
            shares_outstanding (int, none_type): The number of common shares that a company has issued and are held by investors. [optional]  # noqa: E501
            pe_ratio (float, none_type): The price-earnings ratio (P/E ratio) is the ratio for valuing a company that measures its current share price relative to its per-share earnings (EPS). [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
